package com.usky.fire.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.usky.common.core.bean.CommonPage;
import com.usky.fire.domain.JcjAjxx;
import com.usky.fire.mapper.JcjAjxxMapper;
import com.usky.fire.service.JcjAjxxService;
import com.usky.common.mybatis.core.AbstractCrudService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Map;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author ZYJ
 * @since 2023-01-17
 */
@DS("mhsystem")
@Service
public class JcjAjxxServiceImpl extends AbstractCrudService<JcjAjxxMapper, JcjAjxx> implements JcjAjxxService {
    @Override
    CommonPage<JcjAjxx> jcjAjxxList(String streetTown, String startDate, String endDate, String caseType, Integer pageNum, Integer pageSize){
        List<String> streetTownList = new ArrayList<>();
        if(StringUtils.isNotBlank(streetTown)){
            String[] splitList = streetTown.split(",");
            for(int i=0;i<splitList.length;i++){
                streetTownList.add(splitList[i]);
            }
        }
        IPage<JcjAjxx> page = new Page<>(pageNum, pageSize);
        LambdaQueryWrapper<JcjAjxx> queryWrapper = Wrappers.lambdaQuery();
        if(streetTownList.size()>0){
            queryWrapper.in(JcjAjxx::getStreettown, streetTown);
        }
        queryWrapper.between(StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate), JcjAjxx::getLasj, startDate, endDate)
                    .eq(StringUtils.isNotBlank(caseType), JcjAjxx::getAjlx, caseType)
                    .eq(JcjAjxx::getYxx,0)
                    .orderByDesc(JcjAjxx::getId);
        page = this.page(page, queryWrapper);
        return new CommonPage<>(page.getRecords(), page.getTotal(), pageNum, pageSize);

    }

    @Override
    Map<String,Object> jcjAjxxStatistics(String streetTown, String startDate, String endDate){

    }
}
